//=============================================================================
//
// file :        Keithley6221.h
//
// description : Include for the Keithley6221 class.
//
// project :	Keithley6221 control class
//
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// SVN only:
// $HeadURL: $
//
// CVS only:
// $Source:  $
// $Log:  $
//
// copyleft :    European Synchrotron Radiation Facility
//               BP 220, Grenoble 38043
//               FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _KEITHLEY6221_H
#define _KEITHLEY6221_H

#include <tango.h>
//using namespace Tango;

/**
 * @author	$Author:  $
 * @version	$Revision:  $
 */

 //	Add your own constant definitions here.
 //-----------------------------------------------
#include "keithley6221Interface.h"

namespace Keithley6221_ns
{

/**
 * Class Description:
 * This class aims to control a Keithley 6221 current generator
 */

/*
 *	Device States Description:
*  Tango::INIT :     Device initialization in progress
*  Tango::STANDBY :  Device is up and ready
*  Tango::RUNNING :  Current is being delivered
*  Tango::FAULT :    Device initialization failed or fatal error occurred during current generation
*  Tango::ALARM :    The current source is in compliance state
 */


class Keithley6221: public Tango::Device_4Impl
{
public :
	//	Add your own data members here
	//-----------------------------------------


	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attribute member data.
 */
//@{
		Tango::DevBoolean	*attr_AutoRange_read;
		Tango::DevDouble	*attr_Current_read;
		Tango::DevDouble	attr_Current_write;
		Tango::DevString	*attr_Range_read;
//@}

/**
 * @name Device properties
 * Device properties member data.
 */
//@{
/**
 *	Name of the Device providing access to the current source. No default value
 */
	string	currentSourceProxyName;
/**
 *	Compliance value in V. Possible values: [0.1, 105] in 10mV steps.
 */
	Tango::DevDouble	voltageCompliance;
//@}

/**
 *	@name Device properties
 *	Device property member data.
 */
//@{
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	Keithley6221(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	Keithley6221(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	Keithley6221(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one destructor is defined for this class */
//@{
/**
 * The object destructor.
 */	
	~Keithley6221() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method before execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name Keithley6221 methods prototypes
 */

/**
* This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.
*	@return	State Code
*	@exception DevFailed
*/
	virtual Tango::DevState	dev_state();
/**
* This command gets the device status (stored in its <i>device_status</i> data member) and returns it to the caller.
*	@return	Status description
*	@exception DevFailed
*/
	virtual Tango::ConstDevString	dev_status();
//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for AutoRange acquisition result.
 */
	virtual void read_autoRange(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Current acquisition result.
 */
	virtual void read_current(Tango::Attribute &attr);
/**
 *	Write Current attribute values to hardware.
 */
	virtual void write_current(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Range acquisition result.
 */
	virtual void read_range(Tango::Attribute &attr);
/**
 *	Read/Write allowed for autoRange attribute.
 */
	virtual bool is_autoRange_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for current attribute.
 */
	virtual bool is_current_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for range attribute.
 */
	virtual bool is_range_allowed(Tango::AttReqType type);
/**
 *	Execution allowed for AutoRangeOFF command.
 */
	virtual bool is_AutoRangeOFF_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for AutoRangeON command.
 */
	virtual bool is_AutoRangeON_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for GetRange command.
 */
	virtual bool is_GetRange_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for Off command.
 */
	virtual bool is_Off_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for On command.
 */
	virtual bool is_On_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for RangeDOWN command.
 */
	virtual bool is_RangeDOWN_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for RangeUP command.
 */
	virtual bool is_RangeUP_allowed(const CORBA::Any &any);
/**
 * Sets the autoRange OFF
 *	@exception DevFailed
 */
	void	auto_range_off();
/**
 * Sets the autoRange ON
 *	@exception DevFailed
 */
	void	auto_range_on();
/**
 * This command returns the value of the range attribute
 *	@return	Value of the range attribute
 *	@exception DevFailed
 */
	Tango::DevString	get_range();
/**
 * The output is not activated
 *	@exception DevFailed
 */
	void	off();
/**
 * The output is activated
 *	@exception DevFailed
 */
	void	on();
/**
 * This command sets the lower range
 *	@exception DevFailed
 */
	void	range_down();
/**
 * This command sets the upper range
 *	@exception DevFailed
 */
	void	range_up();

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	



protected :	
	//	Add your own data members here
	//-----------------------------------------
	//- get the upper range
	std::string get_upper_range();

	//- get the lower range
	std::string get_lower_range();

	//- range
	Tango::DevString m_range;

	//- current
	double m_current;

	//- autoRange
	bool m_autoRange;

	//- deviceProxy for socketDevice
	Tango::DeviceProxy * m_deviceProxy;

	//- interface for the commands
	keithley6221Interface * m_interface;

	//- The device status during initialization phase.
	std::string m_status;

	//- compliance status
	std::string m_compStatus;

	//- error status
	std::string m_currStatus;

	//- init ok flag
	bool m_init_ok;
};

}	// namespace_ns

#endif	// _KEITHLEY6221_H
